{COPYRIGHT: http://dzn-bf.cba.pl/pr/Licencja.txt
Kompilator: Free Pacal Compiler, http://www.freepascal.org}
program p1;
uses crt;

const
Dekor = 3;
Wrog = 2;
Zdr = 15000;
policSzansa = 10000;
srodoSzansa = 500;

type
dekoracja = object
x:byte;
y:byte;
typ:byte;
end;
{
|---------------|-------|--------|------|
|rodowiska/typy|   1   |   2    |  3   |
|---------------|-------|--------|------|
|  Zwykle    1  | Domy  | Drzewa | Pola |
|---------------|-------|--------|------|
|  Most      2  | Fala  |  Lodz  | //// |
|---------------|-------|--------|------|
|  Pustynia  3  | Kaktus|  Wydma | Oaza |
|---------------|-------|--------|------|
|  Miasto    4  | ///// | Fabryka| Blok |
|---------------|-------|--------|------|
}
wrogo = object
x:byte;
y:byte;
end;

pixel = object
c:char; {Znak}
kol:byte; {kolor}
tlo:byte; {kolor tla}
end;

policjant = object
x:integer;
y:integer;
zdr:byte; {zdrowie}
v:real;
jest:boolean;
fh:byte;
fv:byte;
end;

gracz = object {do tabeli wynikow}
   imie:string;
   punkty:longint;
end;
wa = file of longint;
ea = file of string;

var
c:char;  {input gracza}
x,y,drx,szer:byte;  {wspolrz. wozu, rzedna drogi, szer. drogi}
i,j:byte;           {pomocnicze do tablic}
srodoTla:array[1..4] of byte;
srodoKol:array[1..4] of byte; {tablice do sterowania srodowiskiem}
matrix:array[1..79,1..24] of pixel;    {matryca ekranu}
dek:array[1..Dekor] of dekoracja; {dekoracje}
wr:array[1..Wrog] of wrogo; {Inne samochody}
g:array[1..10] of gracz; {do tabeli}
typ:byte;
srod:byte; {Srodowisko (patrz tabela)}
parz,kolizja:boolean;
temp:integer;
zdrowie,paliwo:word;
punkty:longint;
pol:policjant;
imie:string;
aa:wa;
ba:ea;

procedure wybuch (x,y:byte);
begin
   gotoxy(x,y);
   TextColor(12);
   TextBackground(4);
   write ('*');

   TextColor(14);
   TextBackground(6);
   gotoxy(x-1,y-1);
   write ('\|/');
   gotoxy (x-1,y);
   write ('-');
   gotoxy(x+1,y);
   write ('-');
   gotoxy(x-1,y+1);
   write ('/|\');
   textColor(15);
   TextBackground(0);
end;

procedure wyniki;
begin
   clrscr;
   gotoxy(1,24);
   write ('/||\');
   delay(10);
   gotoxy(77,24);
   write ('/||\');
   delay(10);
   i:=23;
   while (i > 2) do
   begin
      gotoxy(2,i);
      write('||');
      delay(10);
      gotoxy(78,i);
      write ('||');
      delay(10);
      i:=i-1;
   end;
   gotoxy(1,2);
   write ('\||/');
   delay(10);
   gotoxy(77,2);
   write ('\||/');
   delay(10);
   gotoxy(1,1);
   write ('____');
   delay(10);
   gotoxy(77,1);
   write ('____');
   textcolor(10);
   gotoxy(27,3); write ('/'); delay(5);
   gotoxy(28,2); write ('/'); delay(5);
   write ('\'); delay(5);
   gotoxy(30,3); write ('\'); delay(5);
   gotoxy(31,2); write ('/'); delay(10);
   gotoxy(33,3); write ('/'); delay(5);
   gotoxy(34,2); write ('/'); delay(5);
   write ('\'); delay(5);
   gotoxy(36,3); write ('\'); delay(5);
   gotoxy(34,3); write ('-'); delay(5);
   write ('-'); delay(10);
   gotoxy(39,2); write ('|'); delay(05);
   gotoxy(39,3); write ('/'); delay(05);
   gotoxy(38,3); write ('_'); delay(10);
   gotoxy(41,2); write ('|'); delay(05);
   gotoxy(41,3); write ('|'); delay(05);
   write ('_'); delay(10);
   gotoxy(44,2); write ('|'); delay(05);
   gotoxy(44,3); write ('|'); delay(05);
   gotoxy(45,1); write ('_'); delay(05);
   gotoxy(45,2); write ('_'); delay(05);
   gotoxy(45,3); write ('_'); delay(10);
   gotoxy(47,2); write ('|'); delay(05);
   gotoxy(47,3); write ('|'); delay(05);
   gotoxy(48,2); write (')'); delay(10);
   gotoxy(50,2); write ('('); delay(05);
   gotoxy(51,3); write (')'); delay(10);
   gotoxy(53,2); write ('|'); delay(05);
   gotoxy(53,3); write ('|'); delay(05);

   reset(aa);
   reset(ba);
   textcolor(12);
   i:=6;
   j:=1;
   while (i < 24) do
   begin
      read(aa,punkty);
      read(ba,imie);
      gotoxy(13,i);
      write (j,'. ',imie);
      while (wherex < 55) do write ('.');
      write (punkty);
      i:=i+2;
      j:=j+1;
      delay(50);
   end;
   read(aa,punkty);
   read(ba,imie);
   gotoxy(12,24);
   write ('10. ',imie);
   while (wherex < 55) do write ('.');
   write (punkty);
   delay(50);
   close (aa);
   close (ba);
   repeat until keypressed;
   i:=5;
end;

procedure menu;
begin
   clrscr;
   Textcolor(15);
   Textbackground(0);
   i:=10;
   write ('Copyright (c) 2007 -=DZN=-Archer. www.dzn-bf.cba.pl/pr');
   gotoxy(32,10);
   write ('>> Nowa Gra');
   gotoxy(35,12);
   write ('Instrukcje');
   gotoxy(35,14);
   write ('Tablica Wynikow');
   gotoxy(35,16);
   write ('Wyjscie');
   c:='1';
   repeat
      c:= readkey();
      if (c = 'H') and (i > 10) then i := i-2
      else if (c = 'P') and (i < 16) then i :=i+2;
      gotoxy(32,i);
      write ('>>');
      gotoxy(32,i-6);
      write ('  ');
      gotoxy(32,i-4);
      write ('  ');
      gotoxy(32,i-2);
      write ('  ');
      gotoxy(32,i+2);
      write ('  ');
      gotoxy(32,i+4);
      write ('  ');
      gotoxy(32,i+6);
      write ('  ');
      gotoxy(80,24);
      write (c);
   until wherex = 1; {wylapuje enter}
   if (i = 16) then
   begin
      clrscr;
      writeln ('Dzieki za granie w PR!');
      halt;
   end
   else if (i = 14) then wyniki
   else if (i = 12) then
   begin
      clrscr;
      TextColor(15);
      Textbackground(0);
      write ('o');
      TextColor(12);
      write('W');
      textColor(15);
      write ('o');
      gotoxy(1,wherey+1);
      TextColor(12);
      TextBackground(4);
      write ('|');
      TextColor(14);
      write ('O');
      TextColor(12);
      write ('|');
      TextColor(15);
      TextBackground(0);
      gotoxy(1,wherey+1);
      write ('o');
      TextColor(12);
      write ('V');
      TextColor(15);
      write ('o');
      gotoxy(10,1);
      write ('<-- Twoj samochod   ______');
      gotoxy(10,2);
      write ('   Sterowanie -->  | /|\ |');
      gotoxy(29,3);
      write ('|  |  |');
      gotoxy(23,4);
      write ('______|_____|_____         __');
      gotoxy(23,5);
      write ('| /__ |  |  | __\ |       |Z| <-- Pauza');
      gotoxy(23,6);
      write ('| \   | \|/ |   / |        __');
      gotoxy(23,7);
      write ('|_____|_____|_____|       |E| <-- Koniec gry');
      gotoxy (1,9);
      TextColor (15);
      Textbackground(0);
      write ('o');
      gotoxy(3,9);
      write ('o');
      gotoxy(1,11);
      write ('o');
      gotoxy(3,11);
      write ('o');
      Textcolor (12);
      TextBackground(4);
      gotoxy(2,10);
      write ('O');
      TextColor(9);
      Textbackground(1);
      gotoxy(2,9);
      write ('~');
      gotoxy(1,10);
      write ('|');
      gotoxy(3,10);
      write ('|');
      gotoxy(2,11);
      write ('I');
      gotoxy (5,9);
      Textcolor(15);
      Textbackground(0);
      write ('<------ Radiowoz');
      gotoxy (5,10);
      write ('(bedzie utrudnial zycie)');
      gotoxy(1,15);
      writeln ('o-o');
      writeln ('|I|   <-- Zwykly samochod');
      writeln ('o-o         (pzeszkoda)');
      gotoxy(20,13);
      textcolor(12);
      textbackground(5);
      write ('F');
      textcolor(15);
      textbackground(0);
      write ('  <-- Paliwo');
      textBackground(2);
      for i:=1 to 24 do
      begin
         gotoxy(80,25-i);
         write (' ');
      end;
      textbackground(0);
      gotoxy(58,12);
      write ('Wskaznik paliwa -->');
      gotoxy(45,19);
      write ('Stan radiowozu -->');
      temp := 10;
      gotoxy(65,19);
      textBackground(3);
      for i:=1 to 10 do write (' ');
      TextBackground(0);
      gotoxy(1,1);
      i:=5;
      repeat until keypressed;
   end;
   if (i <> 5) then
   begin
      clrscr;
      x:= 40;
      y:= 3;
      szer := random(21)+20;
      typ := 2;
      parz := true;
      srod := 1;
      srodoTla[1] := 2;
      srodoTla[2] := 1;
      srodoTla[3] := 6;
      srodoTla[4] := 7;
      srodoKol[1] := 2;
      srodoKol[2] := 1;
      srodoKol[3] := 6;
      srodoKol[4] := 8;
      paliwo := 3276;

      for j:=1 to 24 do
      begin
         for i:=1 to 79 do
         begin
            matrix[i,j].c := ' ';
            matrix[i,j].kol := 15;
            matrix[i,j].tlo := 0;
         end;
      end;

      drx:= random(szer)+1; {gdzie bedzie droga?}
      x := (drx+drx+szer) div 2; {poczatkowa pozycja - srednia aryt. drog}
      for j:=1 to 24 do
      begin
         matrix[drx,j].c := '|';
         matrix[drx+szer,j].c := '|';
      end;

      for i:=1 to Dekor do
      begin
         dek[i].y := 21;
         dek[i].typ := typ;
      end;
      for i:=1 to Wrog do
      begin
         wr[i].x:=0;
         wr[i].y:=21;
      end;

      zdrowie:=Zdr;
      punkty:=0;
      kolizja := false;
      pol.zdr := 100;
      pol.jest := false;
      pol.fh := 0;
      pol.fv := 0;
   end else menu;
end;

procedure gameover(a:byte); {0-utopienie; 1-kolizja; 2-paliwo}
begin
   delay(250);
   if (a = 0) then
   begin
      Textcolor(11);
      Textbackground(1);
      gotoxy(x,y-1);
      write ('oWo');
      gotoxy(x,y);
      write ('|O|');
      gotoxy(x,y+1);
      write ('oVo');
      delay(250);
      Textcolor(1);
      Textbackground(1);
      gotoxy(x,y-1);
      write ('   ');
      gotoxy(x,y);
      write ('   ');
      gotoxy(x,y+1);
      write ('   ');
   end
   else if (a = 1) then wybuch(x+1,y)
   else if (a = 2) then
   begin
      textBackground(28);
      for i:=1 to 24 do
      begin
         gotoxy(80,25-i);
         write (' ');
      end;
   end;
   delay(250);
   gotoxy(1,4);
   TextColor (random(8)+7);
   Textbackground(random(7));
   writeln ('    ___     __                  ______       ___            _____  ____         ');
   delay(50);
   writeln ('   /  _|   /  \     /\    /\    |  __|      /    \   |\  /| | ___| | __\        ');
   delay(50);
   writeln ('  /  /    / /\ \   /  \  /  \   | |        /  /\  \  ||  || | |    | |_\|       ');
   delay(50);
   writeln ('  | |_   / /__\ \ / /\ \/ /\ \  | |__      | |  |  | ||  || | |__  |   _/       ');
   delay(50);
   writeln ('  | |\\  | ___  | | | \__/  \ | |  __|     \  \/  /  ||  || | ___| | | \        ');
   delay(50);
   writeln ('  \ \_|| | |  | | | |       | | | |__       \    /   \\_//  | |__  | |\ \       ');
   delay(50);
   writeln ('   \__/  |_|  |_| |_|       |_| |____|       \__/     \_/   |____| |_| \_\      ');
   delay(50);
   writeln ('                                                                                ');
   textColor(15);
   Textbackground(0);

   reset (aa);
   reset (ba);
   temp := 1;
   for i:=1 to 10 do
   begin
      read (aa,g[i].punkty);
      if (g[i].punkty > punkty) then temp := temp + 1;
      read (ba,g[i].imie);
   end;
   gotoxy(1,12);
   writeln('Masz ',punkty,' punktow.');
   if (temp = 11) then
   begin
      writeln ('Za malo aby zaistniec na tabeli wynikow');
      c:='1';
      repeat c:= readkey until c <> '1'; {Sprytna pauza}
      menu;
   end
   else
   begin
      gotoxy(1,13);
      write ('Jestes na tabeli wynikow!');
      if (temp = 1) then writeln (' Nowy rekord!')
      else writeln (' Masz ',temp,' miejsce!');
      write ('Jak sie nazywasz? ');
      read (imie);
      i := 10;
      while (i >= temp) do
      begin
         if (i <> 10) then
         begin
            g[i+1].punkty := g[i].punkty;
            g[i+1].imie := g[i].imie;
         end;
         i := i-1;
      end;
      g[temp].punkty := punkty;
      g[temp].imie := imie;
      for i:=3 to 12 do
      begin
         gotoxy(1,i+12);
         write (i-2,'. ',g[i-2].imie);
         while (wherex < 50) do write ('.');;
         write (g[i-2].punkty);
      end;
      close (aa);
      close (ba);

      rewrite (aa);
      rewrite (ba);
      for i:=1 to 10 do
      begin
         write (aa,g[i].punkty);
         write (ba,g[i].imie);
      end;
      close (aa);
      close (ba);

      c:='1';
      delay(1000);
      repeat c:= readkey() until c<>'1';
      menu;
   end;
end;

function wykryj(a,b:integer):boolean;
begin
   wykryj:=false;
   if (matrix[a,b].c = ' ') or (matrix[a,b].c = '.') then wykryj:=true;
end;

procedure pisz(x,y:byte);
begin
   gotoxy(x,y);
   TextColor(matrix[x,y].kol);
   Textbackground(matrix[x,y].tlo);
   write (matrix[x,y].c);
end;

function op(x:integer):integer;
begin
   if (x > drx+szer) then op:= -(70*x div 100) + 50
   else op:= -(70*x div 100) + 32;
   op := op - (punkty div 1000);
end;

procedure rysuj(x,y:byte);          {rysuje woz}
begin
   gotoxy(x,y);
   TextColor(15);
   Textbackground(0);
   write ('o');
   TextColor(12);
   write('W');
   textColor(15);
   write ('o');

   gotoxy(x,y+1);
   TextColor(12);
   TextBackground(4);
   write ('|');
   TextColor(14);
   write ('O');
   TextColor(12);
   write ('|');
   TextColor(15);
   TextBackground(0);

   gotoxy(x,y+2);
   write ('o');
   TextColor(12);
   write ('V');
   TextColor(15);
   write ('o');

   {Zakryjmy smugi - niepotrzebne na linuxie*}
   if (y > 1) then
   begin
      gotoxy (x,y-1);
      for i:=x to x+3 do
      begin
         TextColor(matrix[i,y-1].kol);
         TextBackground(matrix[i,y-1].tlo);
         write (matrix[i,y-1].c);
      end;
      if (y > 2) then
      begin
         gotoxy (x,y-2);
         for i:=x to x+3 do
         begin
            TextColor(matrix[i,y-2].kol);
            TextBackground(matrix[i,y-2].tlo);
            write (matrix[i,y-2].c);
         end;
      end;
   end;

   for i:=y-1 to y+3 do
   begin
      gotoxy(x+3,i);
      TextColor(matrix[x+3,i].kol);
      TextBackground(matrix[x+3,i].tlo);
      write (matrix[x+3,i].c);

      gotoxy(x-1,i);
      TextColor(matrix[x-1,i].kol);
      TextBackground(matrix[x-1,i].tlo);
      write (matrix[x-1,i].c);
   end;
   Textbackground (0); {Aby nie bylo kolorowego paska na dole win}
end;

procedure rysujdroge;
begin
   for j:=1 to 23 do
   begin
      for i:=1 to 79 do
      begin
         matrix[i,j].c := matrix[i,j+1].c;
         matrix[i,j].kol := matrix[i,j+1].kol;
         matrix[i,j].tlo := matrix[i,j+1].tlo;
      end;
   end;

   for i:=1 to 79 do
   begin
      if (i < drx) or (i > (drx+szer)) then
      begin
         matrix[i,24].c := '-';
         matrix[i,24].kol := srodoKol[srod];
         matrix[i,24].tlo := srodoTla[srod];
      end
      else
      begin
         matrix[i,24].c := ' ';
         matrix[i,24].kol := 15;
         matrix[i,24].tlo := 0;
      end;
   end;

   i:=random (255);
   if (i = 1) then typ := 1
   else if (i = 2) then typ := 2
   else if (i = 3) then typ := 3;
   if (i = 99) then
   begin
     j := drx+random(szer)+1;
     matrix[j,24].c := 'F';
     matrix[j,24].kol := 12;
     matrix[j,24].tlo := 5;
   end;

   i := random (Dekor*5);
   if (i <= Dekor) and (i > 0) then
   begin
      if (dek[i].y > 20) then
      begin
         j:=random(72)+1;
         if (j+8 < drx) or (j-8 > drx+szer) then
         begin
            dek[i].x := j;
            dek[i].y := 1;
         end;
      end;
   end;

   i:= random (Wrog*5);
   if (i <= Wrog) and (i > 0) then
   begin
      if (wr[i].y > 20) then
      begin
         j:=random(69)+4;
         if{until} (matrix[j+2,24].c = ' ') and (matrix[j-2,24].c = ' '){;} then
         begin
            wr[i].x := j;
            wr[i].y := 1;
         end;
      end;
   end;

   if (srod <> 2) then
   begin
     i:=random(3);
     if (i = 1) and ( drx > 2) then
     begin
        drx := drx - 1;
     end
     else if (i = 2) and (drx < 38) then
     begin
        drx := drx + 1;
     end
     else
     begin
        i:=random(3);
        if (i=1) and (szer > 20) then szer:=szer - 1
        else if (i=0) and (szer < 38) then szer:=szer + 1;
     end;
   end;
   matrix[drx,24].c := '|'; {rysuj linie drogi}
   matrix[drx,24].kol := 15;
   matrix[drx,24].tlo := 0;
   matrix[drx+szer,24].c := '|';
   matrix[drx+szer,24].kol := 15;
   matrix[drx+szer,24].tlo := 0;
   if (parz = true) then
   begin
      if (szer < 30) then matrix[drx+(szer div 2),24].c := '.' {rysuj pasy}
      else
      begin
         matrix[drx+(szer div 3),24].c := '.';
         matrix[drx+(szer*2 div 3),24].c := '.';
      end;
      parz := false;
   end
   else parz := true;
   if (srod = 1) then
   begin
      for i:=1 to Dekor do
      begin
         if (dek[i].y = 1) and (dek[i].typ = 1) then
         begin
            matrix[dek[i].x,24].tlo := 2;
            matrix[dek[i].x+1,24].c := '/';
            matrix[dek[i].x+1,24].kol := 12;
            matrix[dek[i].x+1,24].tlo := 4;
            matrix[dek[i].x+2,24].c := '\';
            matrix[dek[i].x+2,24].kol := 12;
            matrix[dek[i].x+2,24].tlo := 4;
         end
         else if (dek[i].y = 2) and (dek[i].typ = 1) then
         begin
            for j:=0 to 3 do
            begin
               matrix[dek[i].x+j,24].kol := 12;
               matrix[dek[i].x+j,24].tlo := 4;
            end;
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x+1,24].c := '_';
            matrix[dek[i].x+2,24].c := '_';
            matrix[dek[i].x+3,24].c := '\';
         end
         else if (dek[i].y = 3) and (dek[i].typ = 1) then
         begin
            for j:=0 to 3 do
            begin
               matrix[dek[i].x+j,24].kol := 15;
               matrix[dek[i].x+j,24].tlo := 7;
            end;
            matrix[dek[i].x,24].c := '|';
            matrix[dek[i].x+1,24].c := ' ';
            matrix[dek[i].x+2,24].c := ' ';
            matrix[dek[i].x+3,24].c := '|';
         end
         else if (dek[i].y = 4) and (dek[i].typ = 1) then
         begin
            for j:=0 to 3 do
            begin
               matrix[dek[i].x+j,24].kol := 15;
               matrix[dek[i].x+j,24].tlo := 7;
            end;
            matrix[dek[i].x,24].c := '|';
            matrix[dek[i].x+1,24].c := '|';
            matrix[dek[i].x+2,24].c := '|';
            matrix[dek[i].x+3,24].c := '|';
         end
         {***************** Drzewo *******************}
         else if (dek[i].y = 1) and (dek[i].typ = 2) then
         begin
            for j:=0 to 2 do
            begin
               matrix[dek[i].x+j,24].kol := 10;
               matrix[dek[i].x+j,24].tlo := 2;
            end;
            matrix[dek[i].x,24].c := ' ';
            matrix[dek[i].x+1,24].c := '|';
            matrix[dek[i].x+2,24].c := ' ';
         end
         else if (dek[i].y = 2) and (dek[i].typ = 2) then
         begin
            for j:=0 to 2 do
            begin
               matrix[dek[i].x+j,24].kol := 10;
               matrix[dek[i].x+j,24].tlo := 2;
            end;
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x+1,24].c := '|';
            matrix[dek[i].x+2,24].c := '\';
         end
         else if (dek[i].y = 3) and (dek[i].typ = 2) then
         begin
            for j:=0 to 2 do
            begin
               matrix[dek[i].x+j,24].kol := 10;
               matrix[dek[i].x+j,24].tlo := 2;
            end;
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x+1,24].c := '|';
            matrix[dek[i].x+2,24].c := '\';
         end
         else if (dek[i].y = 4) and (dek[i].typ = 2) then
         begin
            for j:=0 to 2 do
            begin
               matrix[dek[i].x+j,24].kol := 10;
               matrix[dek[i].x+j,24].tlo := 2;
            end;
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x+1,24].c := '|';
            matrix[dek[i].x+2,24].c := '\';
         end
         {********* Pole **************************}
         else if (dek[i].y = 1) and (dek[i].typ = 3) then
         begin
            for j:=dek[i].x to dek[i].x+4 do
            begin
               matrix[j,24].c := '~';
               matrix[j,24].kol := 14;
               matrix[j,24].tlo := 6;
            end;
         end
         else if (dek[i].y = 3) and (dek[i].typ = 3) then
         begin
            for j:=dek[i].x to dek[i].x+4 do
            begin
               matrix[j,24].c := '~';
               matrix[j,24].kol := 14;
               matrix[j,24].tlo := 2;
            end;
         end
         else if (dek[i].y = 2) and (dek[i].typ = 3) then
         begin
            for j:=dek[i].x to dek[i].x+4 do
            begin
               matrix[j,24].c := '~';
               matrix[j,24].kol := 6;
               matrix[j,24].tlo := 6;
            end;
         end
         else if (dek[i].y = 4) and (dek[i].typ = 3) then
         begin
            for j:=dek[i].x to dek[i].x+4 do
            begin
               matrix[j,24].c := '~';
               matrix[j,24].kol := 6;
               matrix[j,24].tlo := 6;
            end;
         end;

         if (dek[i].y < 22) then dek[i].y := dek[i].y +1;
         if (dek[i].y = 21) then dek[i].typ := typ;
      end;
   end
   else if (srod = 2) then
   begin
      for i:=1 to Dekor do
      begin
         {************** Fala **********************}
         if (dek[i].y = 1) and (dek[i].typ = 1) then
         begin
            for j:= 0 to 2 do
            begin
               matrix[dek[i].x+j,24].c := '~';
               matrix[dek[i].x+j,24].kol := 9;
               matrix[dek[i].x+j,24].tlo := 1;
            end;
         end
         {*************** Lodz *************************}
         else if (dek[i].y = 1) and (dek[i].typ = 2) then
         begin
            matrix[dek[i].x,24].c := '_';
            matrix[dek[i].x,24].kol := 13;
            matrix[dek[i].x,24].tlo := 1;
            matrix[dek[i].x+1,24].c := '/';
            matrix[dek[i].x+1,24].kol := 13;
            matrix[dek[i].x+1,24].tlo := 5;
            matrix[dek[i].x+2,24].c := '\';
            matrix[dek[i].x+2,24].kol := 13;
            matrix[dek[i].x+2,24].tlo := 5;
            matrix[dek[i].x+3,24].c := '_';
            matrix[dek[i].x+3,24].kol := 13;
            matrix[dek[i].x+3,24].tlo := 1;
         end
         else if (dek[i].y = 2) and (dek[i].typ = 2) then
         begin
            matrix[dek[i].x,24].c := '\';
            matrix[dek[i].x,24].kol := 14;
            matrix[dek[i].x,24].tlo := 6;
            matrix[dek[i].x+1,24].c := '_';
            matrix[dek[i].x+1,24].kol := 14;
            matrix[dek[i].x+1,24].tlo := 6;
            matrix[dek[i].x+2,24].c := '_';
            matrix[dek[i].x+2,24].kol := 14;
            matrix[dek[i].x+2,24].tlo := 6;
            matrix[dek[i].x+3,24].c := '/';
            matrix[dek[i].x+3,24].kol := 14;
            matrix[dek[i].x+3,24].tlo := 6;
         end;
         if (dek[i].y < 22) then dek[i].y := dek[i].y +1;
         if (dek[i].y = 21) then dek[i].typ := typ;
      end;
   end
   else if (srod = 3) then
   begin
      for i:=1 to Dekor do
      begin
         {************** Kaktus **********************}
         if (dek[i].y = 1) and (dek[i].typ = 1) then
         begin
            matrix[dek[i].x,24].c := 'T';
            matrix[dek[i].x,24].kol := 14;
            matrix[dek[i].x,24].tlo := 6;
         end
         {*************** Wydma *************************}
         else if (dek[i].y = 1) and (dek[i].typ = 2) then
         begin
            matrix[dek[i].x,24].tlo := 6;
            matrix[dek[i].x+1,24].c := '/';
            matrix[dek[i].x+1,24].kol := 14;
            matrix[dek[i].x+1,24].tlo := 6;
            for j:=2 to 5 do
           begin
             matrix[dek[i].x+j,24].c := '~';
             matrix[dek[i].x+j,24].kol := 14;
             matrix[dek[i].x+j,24].tlo := 6;
           end;
           matrix[dek[i].x+6,24].c := '/';
           matrix[dek[i].x+6,24].kol := 14;
           matrix[dek[i].x+6,24].tlo := 6;
         end
         else if (dek[i].y = 2) and (dek[i].typ = 2) then
         begin
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x,24].kol := 14;
            matrix[dek[i].x,24].tlo := 6;
            for j:=1 to 4 do
            begin
               matrix[dek[i].x+j,24].c := '~';
               matrix[dek[i].x+j,24].kol := 14;
               matrix[dek[i].x+j,24].tlo := 6;
            end;
            matrix[dek[i].x+5,24].c := '/';
            matrix[dek[i].x+5,24].kol := 14;
            matrix[dek[i].x+5,24].tlo := 6;
         end
         {*************** Oaza *************************}
         else if (dek[i].y = 1) and (dek[i].typ = 3) then
         begin
            matrix[dek[i].x+1,24].c := '_';
            matrix[dek[i].x+1,24].kol := 9;
            matrix[dek[i].x+1,24].tlo := 6;
            matrix[dek[i].x+2,24].c := '\';
            matrix[dek[i].x+2,24].kol := 10;
            matrix[dek[i].x+2,24].tlo := 2;
            matrix[dek[i].x+3,24].c := '/';
            matrix[dek[i].x+3,24].kol := 10;
            matrix[dek[i].x+3,24].tlo := 2;
            matrix[dek[i].x+4,24].c := '_';
            matrix[dek[i].x+4,24].kol := 9;
            matrix[dek[i].x+4,24].tlo := 6;
         end
         else if (dek[i].y = 2) and (dek[i].typ = 3) then
         begin
            matrix[dek[i].x,24].c := '/';
            matrix[dek[i].x,24].kol := 9;
            matrix[dek[i].x,24].tlo := 1;
            matrix[dek[i].x+1,24].c := ' ';
            matrix[dek[i].x+1,24].kol := 9;
            matrix[dek[i].x+1,24].tlo := 1;
            matrix[dek[i].x+2,24].c := '|';
            matrix[dek[i].x+2,24].kol := 14;
            matrix[dek[i].x+2,24].tlo := 6;
            matrix[dek[i].x+3,24].c := '|';
            matrix[dek[i].x+3,24].kol := 14;
            matrix[dek[i].x+3,24].tlo := 6;
            matrix[dek[i].x+4,24].c := ' ';
            matrix[dek[i].x+4,24].kol := 9;
            matrix[dek[i].x+4,24].tlo := 1;
            matrix[dek[i].x+5,24].c := '\';
            matrix[dek[i].x+5,24].kol := 9;
            matrix[dek[i].x+5,24].tlo := 1;
         end
         else if (dek[i].y = 3) and (dek[i].typ = 3) then
         begin
            matrix[dek[i].x,24].c := '\';
            matrix[dek[i].x,24].kol := 9;
            matrix[dek[i].x,24].tlo := 1;
            matrix[dek[i].x+1,24].c := '_';
            matrix[dek[i].x+1,24].kol := 9;
            matrix[dek[i].x+1,24].tlo := 1;
            matrix[dek[i].x+2,24].c := '_';
            matrix[dek[i].x+2,24].kol := 9;
            matrix[dek[i].x+2,24].tlo := 1;
            matrix[dek[i].x+3,24].c := '_';
            matrix[dek[i].x+3,24].kol := 9;
            matrix[dek[i].x+3,24].tlo := 1;
            matrix[dek[i].x+4,24].c := '_';
            matrix[dek[i].x+4,24].kol := 9;
            matrix[dek[i].x+4,24].tlo := 1;
            matrix[dek[i].x+5,24].c := '/';
            matrix[dek[i].x+5,24].kol := 9;
            matrix[dek[i].x+5,24].tlo := 1;
         end;
         if (dek[i].y < 22) then dek[i].y := dek[i].y +1;
         if (dek[i].y = 21) then dek[i].typ := typ;
      end;
   end
   else if (srod = 4) then
   begin
      for i:=1 to Dekor do
      begin
      {************** Blok1 **********************}
      if (dek[i].y = 1) and (dek[i].typ = 3) then
      begin
         for j:=0 to 7 do
         begin
            matrix[dek[i].x+j,24].c := '_';
            matrix[dek[i].x+j,24].kol := 13;
            matrix[dek[i].x+j,24].tlo := 7;
         end;
      end
      else if (dek[i].y = 2) and (dek[i].typ = 3) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 13;
         matrix[dek[i].x,24].tlo := 5;
         matrix[dek[i].x+1,24].c := '[';
         matrix[dek[i].x+1,24].kol := 9;
         matrix[dek[i].x+1,24].tlo := 1;
         matrix[dek[i].x+2,24].c := ']';
         matrix[dek[i].x+2,24].kol := 9;
         matrix[dek[i].x+2,24].tlo := 1;
         matrix[dek[i].x+3,24].c := ' ';
         matrix[dek[i].x+3,24].tlo := 5;
         matrix[dek[i].x+4,24].c := '[';
         matrix[dek[i].x+4,24].kol := 9;
         matrix[dek[i].x+4,24].tlo := 1;
         matrix[dek[i].x+5,24].c := ']';
         matrix[dek[i].x+5,24].kol := 9;
         matrix[dek[i].x+5,24].tlo := 1;
         matrix[dek[i].x+6,24].c := ' ';
         matrix[dek[i].x+6,24].tlo := 5;
         matrix[dek[i].x+7,24].c := '|';
         matrix[dek[i].x+7,24].kol := 13;
         matrix[dek[i].x+7,24].tlo := 5;
      end
      else if (dek[i].y = 3) and (dek[i].typ = 3) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 13;
         matrix[dek[i].x,24].tlo := 5;
         matrix[dek[i].x+1,24].c := ' ';
         matrix[dek[i].x+1,24].tlo := 5;
         matrix[dek[i].x+2,24].c := '[';
         matrix[dek[i].x+2,24].kol := 9;
         matrix[dek[i].x+2,24].tlo := 1;
         matrix[dek[i].x+3,24].c := ']';
         matrix[dek[i].x+3,24].kol := 9;
         matrix[dek[i].x+3,24].tlo := 1;
         matrix[dek[i].x+4,24].c := ' ';
         matrix[dek[i].x+4,24].tlo := 5;
         matrix[dek[i].x+5,24].c := '[';
         matrix[dek[i].x+5,24].kol := 9;
         matrix[dek[i].x+5,24].tlo := 1;
         matrix[dek[i].x+6,24].c := ']';
         matrix[dek[i].x+6,24].kol := 9;
         matrix[dek[i].x+6,24].tlo := 1;
         matrix[dek[i].x+7,24].c := '|';
         matrix[dek[i].x+7,24].kol := 13;
         matrix[dek[i].x+7,24].tlo := 5;
      end
      else if (dek[i].y = 4) and (dek[i].typ = 3) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 13;
         matrix[dek[i].x,24].tlo := 5;
         matrix[dek[i].x+1,24].c := '_';
         matrix[dek[i].x+1,24].kol := 13;
         matrix[dek[i].x+1,24].tlo := 5;
         matrix[dek[i].x+2,24].c := '_';
         matrix[dek[i].x+2,24].kol := 13;
         matrix[dek[i].x+2,24].tlo := 5;
         matrix[dek[i].x+3,24].c := '|';
         matrix[dek[i].x+3,24].kol := 13;
         matrix[dek[i].x+3,24].tlo := 5;
         matrix[dek[i].x+4,24].c := '|';
         matrix[dek[i].x+4,24].kol := 13;
         matrix[dek[i].x+4,24].tlo := 5;
         matrix[dek[i].x+5,24].c := '_';
         matrix[dek[i].x+5,24].kol := 13;
         matrix[dek[i].x+5,24].tlo := 5;
         matrix[dek[i].x+6,24].c := '_';
         matrix[dek[i].x+6,24].kol := 13;
         matrix[dek[i].x+6,24].tlo := 5;
         matrix[dek[i].x+7,24].c := '|';
         matrix[dek[i].x+7,24].kol := 13;
         matrix[dek[i].x+7,24].tlo := 5;
      end
      {***************** Fabryka ******************}
      else if (dek[i].y = 1) and (dek[i].typ = 2) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 12;
         matrix[dek[i].x,24].tlo := 4;
         matrix[dek[i].x+1,24].c := '|';
         matrix[dek[i].x+1,24].kol := 12;
         matrix[dek[i].x+1,24].tlo := 4;
      end
      else if (dek[i].y = 2) and (dek[i].typ = 2) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 12;
         matrix[dek[i].x,24].tlo := 4;
         matrix[dek[i].x+1,24].c := '|';
         matrix[dek[i].x+1,24].kol := 12;
         matrix[dek[i].x+1,24].tlo := 4;
      end
      else if (dek[i].y = 3) and (dek[i].typ = 2) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 12;
         matrix[dek[i].x,24].tlo := 4;
         matrix[dek[i].x+1,24].c := ' ';
         matrix[dek[i].x+1,24].kol := 12;
         matrix[dek[i].x+1,24].tlo := 4;
         matrix[dek[i].x+2,24].c := '\';
         matrix[dek[i].x+2,24].kol := 12;
         matrix[dek[i].x+2,24].tlo := 4;
         matrix[dek[i].x+3,24].c := '/';
         matrix[dek[i].x+3,24].kol := 12;
         matrix[dek[i].x+3,24].tlo := 4;
         matrix[dek[i].x+4,24].c := '\';
         matrix[dek[i].x+4,24].kol := 12;
         matrix[dek[i].x+4,24].tlo := 4;
         matrix[dek[i].x+5,24].c := '/';
         matrix[dek[i].x+5,24].kol := 12;
         matrix[dek[i].x+5,24].tlo := 4;
         matrix[dek[i].x+6,24].c := '\';
         matrix[dek[i].x+6,24].kol := 12;
         matrix[dek[i].x+6,24].tlo := 4;
      end
      else if (dek[i].y = 4) and (dek[i].typ = 2) then
      begin
         matrix[dek[i].x,24].c := '|';
         matrix[dek[i].x,24].kol := 12;
         matrix[dek[i].x,24].tlo := 4;
         matrix[dek[i].x+7,24].c := '|';
         matrix[dek[i].x+7,24].kol := 12;
         matrix[dek[i].x+7,24].tlo := 4;
         for j:=1 to 6 do
         begin
            matrix[dek[i].x+j,24].c := '_';
            matrix[dek[i].x+j,24].kol := 12;
            matrix[dek[i].x+j,24].tlo := 4;
         end;
      end;
      if (dek[i].y < 22) then dek[i].y := dek[i].y +1;
      if (dek[i].y = 21) then dek[i].typ := typ;
      end;
   end;

   for i:=1 to Wrog do
   begin
      if (wr[i].y = 1) then
      begin
         matrix[wr[i].x-1,24].c := 'o';
         matrix[wr[i].x,24].kol := 11;
         matrix[wr[i].x,24].c := '-';
         matrix[wr[i].x+1,24].c := 'o';
      end
      else if (wr[i].y = 2) then
      begin
         matrix[wr[i].x-1,24].c := '|';
         matrix[wr[i].x,24].c := 'I';
         matrix[wr[i].x+1,24].c := '|';
      end
      else if (wr[i].y = 3) then
      begin
         matrix[wr[i].x-1,24].c := 'o';
         matrix[wr[i].x,24].c := '-';
         matrix[wr[i].x+1,24].c := 'o';
      end;
      if (wr[i].y < 22) then wr[i].y := wr[i].y +1;
   end;

   gotoxy(1,25);
   writeln;
   for i:=1 to 79 do pisz(i,24);
end;

procedure kolizje;
begin
   kolizja := false;
   for j:=y to y+2 do
   begin
      for i:=x to x+2 do
      begin
         if (matrix[i+1,j+2].c = '|') then zdrowie := zdrowie - 1
         else if (matrix[i+1,j+2].c = '-') then
         begin
            if (matrix[i,j].kol <> 1) then
            begin
               zdrowie := zdrowie - 1;
               punkty := punkty - 1;
               matrix[i,j].tlo := 7;
               matrix[i,j].kol := 15;
               continue;
            end
            else if (x > drx+3+szer) or (x < drx-3) then gameover(0);
         end
         else if (matrix[i,j].c = 'F') then
         begin
            paliwo := 3276;
            punkty := punkty + 100;
            gotoxy (i+1,j+2);
            textbackground (0);
            write (' ');
            matrix[i,j].c := ' ';
            matrix[i,j].tlo := 0;
         end
         else if (matrix[i+1,j+2].c = ' ') or (matrix[i+1,j+2].c = '.') then
         else
         begin
            zdrowie := zdrowie - 30;
            punkty := punkty - 2;
            wybuch(i,j+2);
            kolizja := true;
         end;
      end;
   end;
end;

procedure interfejs;
begin
   TextBackground(0);
   TextColor(15);
   gotoxy (65,23);
   temp := zdrowie;
   temp := (temp * 100) div Zdr;
   write ('Zdrowie: ',temp,'%');
   gotoxy (65,21);
   write ('Punkty: ',punkty);
   for i:=65 to 79 do
   begin
      pisz (i,22);
      pisz (i,20);
   end;
   temp := (paliwo div 136);
   if (temp >= 12) then textBackground(2)
   else if (temp < 12) and (temp >= 6) then textBackground(6)
   else textBackground(4);
   for i:=1 to temp do
   begin
      gotoxy(80,25-i);
      write (' ');
   end;

   gotoxy(80,wherey-1);
   Textbackground (0);
   write (' ');

   if (pol.jest = true) then
   begin
      temp := (pol.zdr div 10);
      gotoxy(65,19);
      textBackground(3);
      for i:=1 to temp do write (' ');
      gotoxy(65,18);
      for i:=1 to temp+1 do
      begin
         textcolor (matrix[i+65,18].kol);
         textbackground (matrix[i+65,18].tlo);
         write (matrix[i+65,18].c);
      end;
   end;
   gotoxy(1,1);
   textbackground(0);
end;

procedure rysujRadiowoz;
begin
   if (pol.x > 1) and (pol.x < 75) and (pol.y > 1) and (pol.y < 20) then
   begin
      TextColor (15);
      Textbackground(0);
      gotoxy(pol.x,pol.y);
      write ('o');
      gotoxy(pol.x+2,pol.y);
      write ('o');
      gotoxy(pol.x,pol.y+2);
      write ('o');
      gotoxy(pol.x+2,pol.y+2);
      write ('o');
      if (parz = true) then
      begin
         textcolor(12);
         textbackground(4);
      end
      else
      begin
         textcolor(11);
         textbackground(3);
      end;
      gotoxy(pol.x+1,pol.y+1);
      write ('O');
      TextColor(9);
      Textbackground(1);
      gotoxy(pol.x+1,pol.y);
      write ('~');
      gotoxy(pol.x,pol.y+1);
      write ('|');
      gotoxy(pol.x+2,pol.y+1);
      write ('|');
      gotoxy(pol.x+1,pol.y+2);
      write ('I');

      if (pol.y > 1) then   {usuwamy smugi}
      begin
         gotoxy (pol.x-1,pol.y-1);
         for i:=pol.x-1 to pol.x+4 do
         begin
            TextColor(matrix[i,pol.y-1].kol);
            TextBackground(matrix[i,pol.y-1].tlo);
            write (matrix[i,pol.y-1].c);
         end;
         if (pol.y > 2) then
         begin
            gotoxy (pol.x,pol.y-2);
            for i:=pol.x to pol.x+3 do
            begin
               TextColor(matrix[i,pol.y-2].kol);
               TextBackground(matrix[i,pol.y-2].tlo);
               write (matrix[i,pol.y-2].c);
            end;
         end;
      end;
      for i:=pol.y to pol.y+2 do
      begin
         gotoxy(pol.x-1,i);
         Textcolor(matrix[pol.x-1,j].kol);
         Textbackground(matrix[pol.x-1,j].tlo);
         write (matrix[pol.x-1,j].c);
      end;

      for i:=pol.y to pol.y+2 do
      begin
         gotoxy(pol.x+3,i);
         Textcolor(matrix[pol.x+3,j].kol);
         Textbackground(matrix[pol.x+3,j].tlo);
         write (matrix[pol.x+3,j].c);
      end;

      gotoxy(pol.x-1,pol.y-2); {zeby nie 'gubil zer'}
      Textcolor(matrix[pol.x-1,pol.y-2].kol);
      Textbackground(matrix[pol.x-1,pol.y-2].tlo);
      write (matrix[pol.x-2,pol.y-2].c);

      if (pol.zdr > 0) then {Obliczamy kolizje}
      begin
         for j:=pol.y to pol.y+3 do
         begin
            for i:=pol.x to pol.x+3 do
            begin
               if (i-4 > drx) and (i+4 < drx+szer) then
               begin
                  if (matrix[i,j].c <> ' ') and (matrix[i,j].c <> '.') then
                  begin
                     pol.zdr := pol.zdr - 1;
                     wybuch(i,j);
                  end;
               end;
               if (j = y+3) and (i = x) then pol.zdr := pol.zdr - 1;
            end;
         end;
      end;

      if (pol.zdr < 1) or (pol.zdr > 100) then
      begin
         wybuch(pol.x+1,pol.y+1);
         pol.jest := false;
      end;
   end;
end;

begin

   randomize;
   {Cursoroff;**}
   assign (aa,'tabela.dat');
   assign (ba,'tabela2.dat');
   menu;

   repeat
      paliwo := paliwo - 1;
      if (paliwo < 1) or (paliwo > 65500) then gameover(2);
      if keypressed  then
      begin
              c := readkey;
      end;

      if ({lowercase(}c{)**} = 'M') then x:=x+1
      else if (lowercase(c) = 'e') then gameover(1)
      else if ({lowercase(}c{)} = 'K') then x:=x - 1
      else if ({lowercase(}c{)} = 'H') then y:=y - 1
      else if ({lowercase(}c{)} = 'P') and (kolizja = false) then y:=y + 1
      else if ({lowercase(}c{)} = 'z') then
      begin
         gotoxy(12,35);
         TextColor(15);
         TextBackground(0);
         write ('P A U Z A');
         repeat until keypressed;
      end;
      if (x < 3) then x := 3
      else if (x > 75) then x:=75
      else if (y < 3) then y:=3
      else if (y > 20) then y:= 20;

      punkty := punkty + 1;
      if (zdrowie < Zdr) then zdrowie := zdrowie + random (2);
      if (pol.jest = false) then
      begin
         temp:=random(PolicSzansa);
         if (temp = 0) then
         begin
            pol.jest := true;
            pol.x := x-4;
            pol.y := 1;
            pol.zdr := 100;
         end;
      end;

      rysuj (x,y);
      if (pol.jest = true) then
      begin
         rysujRadiowoz;
         temp := op(y);
         if (pol.v > temp) then pol.y := pol.y + 1
         else pol.y := pol.y + - 1;

         if (pol.y > 20) then pol.v := 0;
         if (pol.x >= x) and (pol.x <= x+2) then
         begin
            if (pol.y >= y) and (pol.y <= y+2) then
            begin
               punkty := punkty - 100;
               pol.zdr := pol.zdr - 1;
            end;
         end;

         {AI}
         if (pol.y < y+6) then
         begin
            if (op(y)+20 > pol.v) then pol.v := pol.v + 1
            else pol.v := pol.v + 0.2;
            if (pol.x = x) then
            begin
               if (wykryj(pol.x+1,pol.y)) then pol.x := pol.x +1
               else if (wykryj(pol.x-1,pol.y)) then pol.x := pol.x - 1;
            end;
         end
         else
         begin
            pol.v:=op(y);
            if (pol.x < x+2) and (pol.x > x-2) then punkty := punkty - 10;
         end;
         if (pol.x > x+2) and (wykryj(pol.x-1,pol.y)) then pol.x := pol.x - 1
         else if (pol.x < x-2) and (wykryj(pol.x+1,pol.y)) then pol.x := pol.x + 1;
      if (wykryj(pol.x,pol.y+1) = false) then
      begin
         if (wykryj(pol.x-1,pol.y+1)) then pol.x := pol.x - 1
         else
         begin
            if (wykryj(pol.x+1,pol.y+1)) then pol.x:=pol.x+1
            else
            begin
               pol.v := pol.v - 1;
               pol.x := pol.x + 1;
            end;
         end;
      end;
      if (pol.x > 80) then {Fail-Safe}
      begin
         pol.x := 0;
         pol.jest := false;
      end;
   end;

      rysujdroge;
      kolizje;
      if (kolizja = true) then
      begin
         if (y > 4) then y:=y-1
         else
         begin
            if (x < 74) then x:=x + 1
            else x:=x - 1;
         end;
      end;
      interfejs;

      temp := random(srodoSzansa);
      if (temp = 0) then srod := random(4)+1;
      if (zdrowie < 10) or (zdrowie > 15000) then gameover(1);
      delay (op(y));
   until false;
end.
